<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Task 36.50</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

</head>
<body>
    <div class="container">
        <h2 style="text-align: center;">Danh sách người dùng</h2>
        
        <table id="user-table" class="table table-bordered table-striped table-hover">
          <thead>
            <tr>
              <th>Mã người dùng</th>
              <th>Firstname</th>
              <th>Lastname</th>
              <th>Country</th>
              <th>Subject</th>
              <th>Customer Type</th>
              <th>Register Status</th>
              <th>Action</th>
            </tr>
          </thead>
          <tbody>
            
          </tbody>
        </table>
      </div>
</body>
<script>
    "use strict";
/*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";
    const gCONTENT_TYPE = "application/json";

    // Biến toàn cục để lưu trữ id user đang đc update or delete. Mặc định = 0;
    var gUserId = 0;
    var gUserObj = {};

    // Biến mảng hằng số chứa danh sách tên các thuộc tính
    var gNameCol = ["id", "firstname", "lastname", "country", "subject","customerType", "registerStatus", "action"];
    // Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
    const gUSER_ID_COL = 0;
    const gFIRST_NAME_COL = 1;
    const gLAST_NAME_COL = 2;
    const gCOUNTRY_COL = 3;
    const gSUBJECT_COL = 4;
    const gCUSTOMER_TYPE_COL = 5;
    const gREGISTER_STATUS_COL = 6;
    const gACTION_COL = 7;
    var gUserTable =  $("#user-table").DataTable({
        columns: [
          {data: gNameCol[gUSER_ID_COL]},
          {data: gNameCol[gFIRST_NAME_COL]},
          {data: gNameCol[gLAST_NAME_COL]},
          {data: gNameCol[gCOUNTRY_COL]},
          {data: gNameCol[gSUBJECT_COL]},
          {data: gNameCol[gCUSTOMER_TYPE_COL]},
          {data: gNameCol[gREGISTER_STATUS_COL]},
          {data: gNameCol[gACTION_COL]}
            ],
        columnDefs: [ //định nghĩa các cột hiển thị
          { targets: gUSER_ID_COL,
            className: "text-center"},
          { targets: gACTION_COL,
            className: "text-center", 
            defaultContent: `
            <img class="edit-user" src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
            <img class="delete-user" src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
            `
            },
        ]
      });
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function(){
        onPageLoading();
    });
    //3-U: gán sự kiện sửa
    $("#user-table").on("click",".edit-user",function(){
        onBtnEditUserClick(this);
    });
    //4-D: gán sự kiện nút xóa 
    $("#user-table").on("click",".delete-user",function(){
        onBtnDeleteUserClick(this);
    });
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading(){
        //1-R: Read /Load user to data table
        getAllUsers();
    }
    //hàm xử lý sự kiện ấn icon edit user
    function onBtnEditUserClick(paramBtnEdit){
        //lưu thông tin user id vào biến toàn cục
        gUserId = getUserIdFromButton(paramBtnEdit);
        console.log("Id của user tương ứng: " + gUserId);
    }
    //hàm xử lý sự kiện ấn icon delete user
    function onBtnDeleteUserClick(paramBtnDelete){
        //lưu thông tin user id vào biến toàn cục
        gUserId = getUserIdFromButton(paramBtnDelete);
        console.log("Id của user tương ứng: " + gUserId);
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //load users to data table
    function loadDataToUserTable(paramUsers){
        gUserTable.clear();
        gUserTable.rows.add(paramUsers);
        gUserTable.draw();
    }

    //gọi API load all users
    function getAllUsers() {
        $.ajax({
            url: gBASE_URL,
            type: "GET",
            success: function(paramUsers){
                //debugger;
                console.log(paramUsers);
                loadDataToUserTable(paramUsers);
            },
            error: function(paramErr){
                console.log(paramErr.status);
            }
        });
    }
    //hàm xác định user id từ button
    function getUserIdFromButton(paramButton){
        var vTableRow = $(paramButton).parents("tr");
        var vUserRowData = gUserTable.row(vTableRow).data();
        gUserObj = vUserRowData;
        return vUserRowData.id;
    }
</script>
</html>